import inspect
from run import Task


class FunctionTask(Task):

    # Public

    def __init__(self, __function__, *args, **kwargs):
        self.__function = __function__
        super().__init__(*args, **kwargs)

    @property
    def meta_docstring(self):
        return self.meta_inspect(
            name='docstring', lookup=True,
            default=str(inspect.getdoc(self.__function)).strip())

    def meta_invoke(self, *args, **kwargs):
        return self.__function(*args, **kwargs)

    @property
    def meta_signature(self):
        signature = str(inspect.signature(self.__function))
        return self.meta_inspect(
            name='signature', lookup=True, default=signature)
